<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="60px">
      <el-form-item label="题ID" prop="questionId">
        <el-input v-model="queryParams.questionId" placeholder="请输入题ID" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="纠错人" prop="userId">
        <el-input v-model="queryParams.userId" placeholder="请输入纠错人" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="状态" prop="state">
        <el-input v-model="queryParams.state" placeholder="请输入状态" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd"
          v-hasPermi="['learn:questionCorrect:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
          v-hasPermi="['learn:questionCorrect:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['learn:questionCorrect:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['learn:questionCorrect:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="questionCorrectList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="纠错id" align="center" prop="id" />
      <el-table-column label="题ID" align="center" prop="questionId" />
      <el-table-column label="纠错人" align="center" prop="userId" />
      <el-table-column label="纠正说明" align="center" prop="remark" />
      <el-table-column label="状态" align="center" prop="state" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['learn:questionCorrect:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
            v-hasPermi="['learn:questionCorrect:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改题纠错对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="questionCorrectRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="题ID" prop="questionId">
          <el-input v-model="form.questionId" placeholder="请输入题ID" />
        </el-form-item>
        <el-form-item label="纠错人" prop="userId">
          <el-input v-model="form.userId" placeholder="请输入纠错人" />
        </el-form-item>
        <el-form-item label="纠正说明" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="状态" prop="state">
          <el-input v-model="form.state" placeholder="请输入状态" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="QuestionCorrect">
import { listQuestionCorrect, getQuestionCorrect, delQuestionCorrect, addQuestionCorrect, updateQuestionCorrect } from "@/api/learn/questionCorrect"

const { proxy } = getCurrentInstance()

const questionCorrectList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    questionId: null,
    userId: null,
    state: null,
  },
  rules: {
    questionId: [
      { required: true, message: "题ID不能为空", trigger: "blur" }
    ],
    userId: [
      { required: true, message: "纠错人不能为空", trigger: "blur" }
    ],
    remark: [
      { required: true, message: "纠正说明不能为空", trigger: "blur" }
    ],
    state: [
      { required: true, message: "状态不能为空", trigger: "blur" }
    ],
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询题纠错列表 */
function getList() {
  loading.value = true
  listQuestionCorrect(queryParams.value).then(response => {
    questionCorrectList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    questionId: null,
    userId: null,
    remark: null,
    state: null,
    createTime: null,
    updateTime: null
  }
  proxy.resetForm("questionCorrectRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加题纠错"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getQuestionCorrect(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改题纠错"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["questionCorrectRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateQuestionCorrect(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addQuestionCorrect(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除题纠错编号为"' + _ids + '"的数据项？').then(function () {
    return delQuestionCorrect(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => { })
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('learn/questionCorrect/export', {
    ...queryParams.value
  }, `questionCorrect_${new Date().getTime()}.xlsx`)
}

getList()
</script>
